var api = require("../../utils/api.js");
import { Page } from '../../utils/scan';
import { API_USE_COUPON } from '../../const/apiurl'
import { ACTION_GO_SCAN } from '../../const/actioncmd'
import { ACTION_GET_ACCOUNT } from '../../const/actioncmd'
import { ACTION_DIRECT_PAYMENT } from '../../const/actioncmd'
import { ACTION_CONVERT_COUPON } from '../../const/actioncmd'

Page({
  data: {
    //显示弹窗，>1为显示，2loading 3 result success 4 result failed
    scanDialogDisplay: 1
  },

  onLoad() {

  },

  onShow(){
    my.ix.onBuddyMessage({
      success: (res) => {
        console.info(`onBuddyMessage success: ${JSON.stringify(res)}`);
        if(res.action == ACTION_GO_SCAN){
          my.ix.sendBuddyMessage({
            // 填入目标小程序的 AppID
            target: getApp().globalData.backScreenAppId,
            data: {
              action: ACTION_GO_SCAN,
              data: null
            },
            success: (res) => {
              console.info(`sendBuddyMessage success: ${JSON.stringify(res)}`);
              //跳转到扫码页面
              my.reLaunch({
                url: "/pages/scan/scan",
              });
            },
            fail: (res) => {
              console.info(`sendBuddyMessage failed: ${JSON.stringify(res)}`);
            }
          });
        } else if(res.action == ACTION_GET_ACCOUNT){
          var message = {
            data:getApp().globalData.localAccountInfo,
            action:ACTION_GET_ACCOUNT
          }
          my.ix.sendBuddyMessage({
            // 填入目标小程序的 AppID
            target: getApp().globalData.backScreenAppId,
            data: {
              action: ACTION_GET_ACCOUNT,
              data: message
            },
            success: (res) => {
              console.info(`sendBuddyMessage success: ${JSON.stringify(res)}`);
            },
            fail: (res) => {
              console.info(`sendBuddyMessage failed: ${JSON.stringify(res)}`);
            }
          });
          
        }else if (res.action == ACTION_DIRECT_PAYMENT) {
          //直接收款
          my.ix.sendBuddyMessage({
            target: getApp().globalData.backScreenAppId,
            data: {
              action: ACTION_DIRECT_PAYMENT,
              data: res.data
            },
            success: (sres) => {
              console.log("通知后屏小程序跳转到结算页面  成功 ===》" + JSON.stringify(sres));
              //去结算页面
              my.reLaunch({
                url: "/pages/balance/balance?totalPrice=" + res.data + "&totalQuantity=0&totalDisc=0",
              });
            },
            fail: (fres) => {
              console.log("通知后屏小程序跳转到结算页面 失败 ===》 " + JSON.stringify(fres));
            }
          })
        }else if(res.action == ACTION_CONVERT_COUPON){
          //兑换券 
          this.setData({scanDialogDisplay:res.data})
        }
      }
    });
  },

 

  onHide() {
    // 页面隐藏
    //关闭后屏监听
    my.ix.offBuddyMessage();
  },


  onReady() {
    if (my.canIUse('hideBackHome')) {
      my.hideBackHome();
    }
  },

  //核销券
  verifyCoupon(code) {
    this.setData({scanDialogDisplay:2})
    this.sendConvertCouponToBack(2)
    var couponRequest = api.createCommonRequest();
    couponRequest.couponCode = code;
    console.log("核销券的请求 ==>" + JSON.stringify(couponRequest));
    let context = this;
    my.request({
      url: getApp().globalData.BASE_URL + API_USE_COUPON,
      method: 'POST',
      dataType: 'json',
      timeout: 30000,
      data: couponRequest,
      success: (res) => {
        if (res.data.success != true) {
          context.sendConvertCouponToBack(4)
          this.setData({scanDialogDisplay:4})
          console.log("核销券失败 ==>" + res.data.message);
        } else {
          context.sendConvertCouponToBack(3)
          this.setData({scanDialogDisplay:3})
          console.log("核销券成功 ==>" + JSON.stringify(res));
        }
      },
      fail: (res) => {
        context.sendConvertCouponToBack(4)
        this.setData({scanDialogDisplay:4})
        console.log("核销券失败 ==>" + JSON.stringify(res));
        my.showToast({
          type: 'exception',
          content: api.decodeErrorMessage(res.error),
          duration: 2000
        });
      }
    });
  },


  //同步兑换券到后台
  sendConvertCouponToBack(e){
     my.ix.sendBuddyMessage({
            // 填入目标小程序的 AppID
            target: getApp().globalData.backScreenAppId,
            data: {
              action: ACTION_CONVERT_COUPON,
              data: e
            },
            success: (sres) => {
            },
            fail: (fres) => {
              sendConvertCouponToBack(e)
              console.info(`sendBuddyMessage failed: ${JSON.stringify(res)}`);
            }
          });
  }
 



});
